AUI_SCROLLING_TEXT_PANEL_OUT = 1
AUI_SCROLLING_TEXT_PANEL_IN = 2
AUI_SCROLLING_TEXT_PANEL_REPORT = 3

AUI_SCROLLING_TEXT_EXP = 1
AUI_SCROLLING_TEXT_CXP = 2
AUI_SCROLLING_TEXT_AP = 3
AUI_SCROLLING_TEXT_TELVAR = 4
AUI_SCROLLING_TEXT_DAMAGE_OUT = 5
AUI_SCROLLING_TEXT_HEAL_OUT = 6
AUI_SCROLLING_TEXT_CRIT_DAMAGE_OUT = 7
AUI_SCROLLING_TEXT_CRIT_HEAL_OUT = 8
AUI_SCROLLING_TEXT_DAMAGE_IN = 9
AUI_SCROLLING_TEXT_HEAL_IN = 10
AUI_SCROLLING_TEXT_CRIT_DAMAGE_IN = 11
AUI_SCROLLING_TEXT_CRIT_HEAL_IN = 12
AUI_SCROLLING_TEXT_COMBAT_START = 13
AUI_SCROLLING_TEXT_COMBAT_END = 14
AUI_SCROLLING_TEXT_PROC = 15
AUI_SCROLLING_TEXT_ULTI_READY = 16
AUI_SCROLLING_TEXT_POTION_READY = 17

local LMP = LibStub("LibMediaProvider-1.0")
local SCROLLING_TEXT_SCENE_FRAGMENT = nil

local isLoaded = false
local isPreviewShow = false
local assembledData = {}	

local function OnMouseDown(_eventCode, _button, _ctrl, _alt, _shift, _control)
	if _button == 1 then
		_control:SetMovable(true)
		_control:StartMoving()
	end
end

local function OnMouseUp(_eventCode, _button, _ctrl, _alt, _shift, _control, _positionData)
	_, _positionData.point, _, _positionData.relativePoint, _positionData.offsetX, _positionData.offsetY = _control:GetAnchor()
	
	_control:SetMovable(false)
end

local function CreateUI()
	AUI_Scrolling_Text_ReportPanel:ClearAnchors()
	AUI_Scrolling_Text_ReportPanel:SetAnchor(AUI.Settings.Combat.scrolling_text_report_position.point, GUIROOT, AUI.Settings.Combat.scrolling_text_report_position.relativePoint, AUI.Settings.Combat.scrolling_text_report_position.offsetX, AUI.Settings.Combat.scrolling_text_report_position.offsetY)	
	
	AUI_Scrolling_Text_OutgoingPanel:ClearAnchors()
	AUI_Scrolling_Text_OutgoingPanel:SetAnchor(AUI.Settings.Combat.scrolling_text_outgoing_position.point, GUIROOT, AUI.Settings.Combat.scrolling_text_outgoing_position.relativePoint, AUI.Settings.Combat.scrolling_text_outgoing_position.offsetX, AUI.Settings.Combat.scrolling_text_outgoing_position.offsetY)	
	
	AUI_Scrolling_Text_IncomingPanel:ClearAnchors()
	AUI_Scrolling_Text_IncomingPanel:SetAnchor(AUI.Settings.Combat.scrolling_text_incomming_position.point, GUIROOT, AUI.Settings.Combat.scrolling_text_incomming_position.relativePoint, AUI.Settings.Combat.scrolling_text_incomming_position.offsetX, AUI.Settings.Combat.scrolling_text_incomming_position.offsetY)	
	
	AUI_Scrolling_Text_ReportPanel:SetHandler("OnMouseDown", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseDown(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_ReportPanel) end)
	AUI_Scrolling_Text_ReportPanel:SetHandler("OnMouseUp", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseUp(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_ReportPanel, AUI.Settings.Combat.scrolling_text_report_position) end)
	
	AUI_Scrolling_Text_OutgoingPanel:SetHandler("OnMouseDown", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseDown(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_OutgoingPanel) end)
	AUI_Scrolling_Text_OutgoingPanel:SetHandler("OnMouseUp", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseUp(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_OutgoingPanel, AUI.Settings.Combat.scrolling_text_outgoing_position) end)
	
	AUI_Scrolling_Text_IncomingPanel:SetHandler("OnMouseDown", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseDown(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_IncomingPanel) end)
	AUI_Scrolling_Text_IncomingPanel:SetHandler("OnMouseUp", function(_eventCode, _button, _ctrl, _alt, _shift) OnMouseUp(_eventCode, _button, _ctrl, _alt, _shift, AUI_Scrolling_Text_IncomingPanel, AUI.Settings.Combat.scrolling_text_incomming_position) end)	
	
	AUI_Scrolling_Text_ReportPanel_BG_Text:SetText(AUI.L10n.GetString("event"))
	AUI_Scrolling_Text_OutgoingPanel_BG_Text:SetText(AUI.L10n.GetString("outgoing"))
	AUI_Scrolling_Text_IncomingPanel_BG_Text:SetText(AUI.L10n.GetString("incoming"))
end

local function SetScrollingControlLayout(_control)
	local size = _control.Size or 0

	local width = size
	local Height = size
	local text = _control.Text or ""
	local showIcon = _control.ShowIcon
	local iconTexture = _control.IconTexture
	local suffix = _control.Suffix
	local textColor = _control.TextColor
	local fontArt = _control.FontArt or "Univers 67"
	
	local textControl = GetControl(_control, "_Text")
	local suffixControl = GetControl(_control, "_Suffix")
	local iconContainerControl = GetControl(_control, "_IconContainer")

	textControl:SetFont(LMP:Fetch('font', fontArt) .. "|" .. size .. "|" .. "soft-shadow-thick")
	textControl:SetText(text)
	
	if suffixControl then
		suffixControl:SetFont(LMP:Fetch('font', fontArt) .. "|" .. size - (size / 2.7) .. "|" .. "soft-shadow-thick")
		suffixControl:SetText(suffix)
	end		
	
	local textWidth, textHeight = textControl:GetTextDimensions() 
	width = textWidth
	
	if textColor then
		textControl:SetColor(textColor:UnpackRGBA())
	end	
	
	if iconContainerControl then
		local iconTextureControl = GetControl(iconContainerControl, "_Icon")
		iconContainerControl:SetDimensions(size + 6, size + 6)
		iconTextureControl:SetDimensions(size, size)
		iconTextureControl:SetTexture(iconTexture)
	
		if showIcon and iconTexture then
			iconContainerControl:SetHidden(false)
		else
			iconContainerControl:SetHidden(true)
		end	
		
		width = width + (size + 12)
	else
		width = width + size
	end
	
	_control:SetDimensions(width, size)
end

local function InsertScrollingControl(_control, _data)
	local str = _data.value or ""

	if _data.scrollingTextType == AUI_SCROLLING_TEXT_DAMAGE_OUT then
		_control.Text = AUI.String.ToFormatedNumber(str)		
		_control.Size = AUI.Settings.Combat.scrolling_text_out_damage_normal_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_out_show_icons
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_out_color_normal)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_damage_out_normal_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_CRIT_DAMAGE_OUT then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_out_damage_crit_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_out_show_icons		
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_out_color_crit)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_damage_out_crit_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_HEAL_OUT then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_out_heal_normal_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_out_show_icons	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_out_color_normal)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_heal_out_normal_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_CRIT_HEAL_OUT then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_out_heal_crit_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_out_show_icons	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_out_color_crit)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_heal_out_crit_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_DAMAGE_IN then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_in_damage_normal_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_in_show_icons
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_in_color_normal)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_damage_in_normal_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_CRIT_DAMAGE_IN then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_in_damage_crit_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_in_show_icons
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_in_color_crit)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_damage_in_crit_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_HEAL_IN then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_in_heal_normal_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_in_show_icons	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_in_color_normal)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_heal_in_normal_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_CRIT_HEAL_IN then
		_control.Text = AUI.String.ToFormatedNumber(str)
		_control.Size = AUI.Settings.Combat.scrolling_text_in_heal_crit_size
		_control.ShowIcon = AUI.Settings.Combat.scrolling_text_in_show_icons	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_in_color_crit)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_heal_in_crit_font_art
		
		if _data.assembleCount > 1 then
			if _control.Text then
				_control.Text = _data.value .. " x" .. _data.assembleCount
			end
		end			
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_EXP then			
		_control.Text = AUI.String.ToFormatedNumber(str) .. " EXP"
		_control.Size = AUI.Settings.Combat.scrolling_text_exp_size
		_control.ShowIcon = false
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_exp_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_exp_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_CXP then	
		_control.Text = AUI.String.ToFormatedNumber(str) .. " CXP"
		_control.Size = AUI.Settings.Combat.scrolling_text_cxp_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_cxp_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_cxp_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_AP then
		_control.Text = AUI.String.ToFormatedNumber(str) .. " AP"
		_control.Size = AUI.Settings.Combat.scrolling_text_ap_size
		_control.ShowIcon = false
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_ap_color)	
		_control.FontArt = AUI.Settings.Combat.scrolling_text_ap_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_TELVAR then
		_control.Text = AUI.String.ToFormatedNumber(str) .. " " .. AUI.L10n.GetString("T'V")
		_control.Size = AUI.Settings.Combat.scrolling_text_telvar_size
		_control.ShowIcon = false
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_telvar_color)	
		_control.FontArt = AUI.Settings.Combat.scrolling_text_telvar_font_art		
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_COMBAT_START then
		_control.Text = str
		_control.Size = AUI.Settings.Combat.scrolling_text_combat_start_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_combat_start_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_combat_start_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_COMBAT_END then
		_control.Text = str
		_control.Size = AUI.Settings.Combat.scrolling_text_combat_end_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_combat_end_color)	
		_control.FontArt = AUI.Settings.Combat.scrolling_text_combat_end_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_PROC then
		_control.Text = str
		_control.Size = AUI.Settings.Combat.scrolling_text_instant_cast_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_instant_cast_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_instant_cast_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_ULTI_READY then
		_control.Text = str
		_control.Size = AUI.Settings.Combat.scrolling_text_ultimate_ready_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_ultimate_ready_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_ultimate_ready_font_art
	elseif _data.scrollingTextType == AUI_SCROLLING_TEXT_POTION_READY then
		_control.Text = str
		_control.Size = AUI.Settings.Combat.scrolling_text_potion_ready_size
		_control.ShowIcon = false	
		_control.TextColor = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_potion_ready_color)
		_control.FontArt = AUI.Settings.Combat.scrolling_text_potion_ready_font_art		
	end
	
	if _data.suffix then
		_control.Suffix = _data.suffix		
	end
	
	_control.IconTexture = _data.iconTexture

	SetScrollingControlLayout(_control)
end

function AUI.Combat.Text.UpdateUI()
	if not isLoaded then
		return
	end	
	
	AUI_Scrolling_Text_ReportPanel:SetDimensions(AUI.Settings.Combat.scrolling_text_report_main_window_width, AUI.Settings.Combat.scrolling_text_report_main_window_height)
	AUI_Scrolling_Text_OutgoingPanel:SetDimensions(AUI.Settings.Combat.scrolling_text_out_main_window_width, AUI.Settings.Combat.scrolling_text_out_main_window_height)
	AUI_Scrolling_Text_IncomingPanel:SetDimensions(AUI.Settings.Combat.scrolling_text_in_main_window_width, AUI.Settings.Combat.scrolling_text_in_main_window_height)
end
	
function InsertAssembledData()		
	for panelType, list in pairs(assembledData) do	
		for scrollingTextType, data in pairs(list) do	
			data.value = data.value * data.assembleCount
			AUI.Animations.StartAnimation(data.controlName, data.panel, data.duration, data.animationType, data.animationMode, AUI_ALIGNMENT_TOPLEFT, 0, 0, 0, 0, true, function(control) InsertScrollingControl(control, data) end)
			assembledData[panelType][scrollingTextType] = nil
		end
		assembledData[panelType] = nil
	end
end	
	
function AUI.Combat.Text.InsertMessage(_value, _scrollingTextType, _panelType, _iconTexture, _suffix)	
	if not isLoaded or not _panelType then
		return
	end	

	local assemble = false

	local data = {value = _value, assembleCount = 0, iconTexture = _iconTexture, suffix = _suffix, scrollingTextType = _scrollingTextType}
	
	local panel = AUI_Scrolling_Text_ReportPanel
	local controlName = "AUI_Scrolling_Simple_Text_Control"
	local animationType = AUI.Settings.Combat.scrolling_text_report_animation
	local animationMode = AUI.Settings.Combat.scrolling_text_report_animation_mode
	local duration = AUI.Settings.Combat.scrolling_text_report_duration * 1000
	
	if _panelType == AUI_SCROLLING_TEXT_PANEL_OUT then
		panel = AUI_Scrolling_Text_OutgoingPanel
		animationType = AUI.Settings.Combat.scrolling_text_out_animation
		animationMode = AUI.Settings.Combat.scrolling_text_out_animation_mode
		controlName = "AUI_Scrolling_Text_Control"
		duration = AUI.Settings.Combat.scrolling_text_out_duration * 1000
	elseif _panelType == AUI_SCROLLING_TEXT_PANEL_IN then	
		panel = AUI_Scrolling_Text_IncomingPanel
		animationType = AUI.Settings.Combat.scrolling_text_in_animation
		animationMode = AUI.Settings.Combat.scrolling_text_in_animation_mode
		controlName = "AUI_Scrolling_Text_Control"
		duration = AUI.Settings.Combat.scrolling_text_in_duration * 1000
	end
	
	if _scrollingTextType == AUI_SCROLLING_TEXT_DAMAGE_OUT then
		if AUI.Settings.Combat.scrolling_text_assemble_damage_out_normal then
			assemble = true
		end	
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_CRIT_DAMAGE_OUT then
		if AUI.Settings.Combat.scrolling_text_assemble_damage_out_crit then
			assemble = true
		end			
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_HEAL_OUT then
		if AUI.Settings.Combat.scrolling_text_assemble_heal_out_normal then
			assemble = true
		end	
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_CRIT_HEAL_OUT then
		if AUI.Settings.Combat.scrolling_text_assemble_heal_out_crit then
			assemble = true
		end			
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_DAMAGE_IN then
		if AUI.Settings.Combat.scrolling_text_assemble_damage_in_normal then
			assemble = true
		end	
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_CRIT_DAMAGE_IN then
		if AUI.Settings.Combat.scrolling_text_assemble_damage_in_crit then
			assemble = true
		end			
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_HEAL_IN then
		if AUI.Settings.Combat.scrolling_text_assemble_heal_in_normal then
			assemble = true
		end	
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_CRIT_HEAL_IN then
		if AUI.Settings.Combat.scrolling_text_assemble_heal_in_crit then
			assemble = true
		end			
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_EXP then
		if AUI.Settings.Combat.scrolling_text_assemble_exp then
			assemble = true
		end				
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_CXP then
		if AUI.Settings.Combat.scrolling_text_assemble_cxp then
			assemble = true
		end		
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_AP then
		if AUI.Settings.Combat.scrolling_text_assemble_ap then
			assemble = true
		end		
	elseif _scrollingTextType == AUI_SCROLLING_TEXT_TELVAR then
		if AUI.Settings.Combat.scrolling_text_assemble_telvar then
			assemble = true
		end				
	end
	
	if isPreviewShow then
		assemble = false
	end
	
	if assemble then
		data.controlName = controlName
		data.panel = panel
		data.duration = duration
		data.animationType = animationType
		data.animationMode = animationMode
	
		if not assembledData[_panelType] then
			assembledData[_panelType]= {}
		end	
	
		if not assembledData[_panelType][_scrollingTextType] then
			assembledData[_panelType][_scrollingTextType] = data
			assembledData[_panelType][_scrollingTextType].assembleCount = 1
		else
			if assembledData[_panelType][_scrollingTextType].value == data.value or _scrollingTextType == AUI_SCROLLING_TEXT_EXP or _scrollingTextType == AUI_SCROLLING_TEXT_CXP or _scrollingTextType == AUI_SCROLLING_TEXT_AP or _scrollingTextType == AUI_SCROLLING_TEXT_TELVAR then	
				assembledData[_panelType][_scrollingTextType].assembleCount = assembledData[_panelType][_scrollingTextType].assembleCount + 1
			end
		end
	else
		AUI.Animations.StartAnimation(controlName, panel, duration, animationType, animationMode, AUI_ALIGNMENT_TOPLEFT, 0, 0, 0, 0, true, function(control) InsertScrollingControl(control, data) end)	
	end
end

function AUI.Combat.Text.SetOutgoingPanelToDefaultPosition(defaultSettings)
	if not isLoaded then
		return
	end

	AUI_Scrolling_Text_OutgoingPanel:ClearAnchors()
	AUI_Scrolling_Text_OutgoingPanel:SetAnchor(defaultSettings.scrolling_text_outgoing_position.point, GuiRoot, defaultSettings.scrolling_text_outgoing_position.relativePoint, defaultSettings.scrolling_text_outgoing_position.offsetX, defaultSettings.scrolling_text_outgoing_position.offsetY)
	_, AUI.Settings.Combat.scrolling_text_outgoing_position.point, _, AUI.Settings.Combat.scrolling_text_outgoing_position.relativePoint, AUI.Settings.Combat.scrolling_text_outgoing_position.offsetX, AUI.Settings.Combat.scrolling_text_outgoing_position.offsetY = AUI_Scrolling_Text_OutgoingPanel:GetAnchor()
end

function AUI.Combat.Text.SetIncomingPanelToDefaultPosition(defaultSettings)
	if not isLoaded then
		return
	end

	AUI_Scrolling_Text_IncomingPanel:ClearAnchors()
	AUI_Scrolling_Text_IncomingPanel:SetAnchor(defaultSettings.scrolling_text_incomming_position.point, GuiRoot, defaultSettings.scrolling_text_incomming_position.relativePoint, defaultSettings.scrolling_text_incomming_position.offsetX, defaultSettings.scrolling_text_incomming_position.offsetY)
	_, AUI.Settings.Combat.scrolling_text_incomming_position.point, _, AUI.Settings.Combat.scrolling_text_incomming_position.relativePoint, AUI.Settings.Combat.scrolling_text_incomming_position.offsetX, AUI.Settings.Combat.scrolling_text_incomming_position.offsetY = AUI_Scrolling_Text_IncomingPanel:GetAnchor()
end

function AUI.Combat.Text.SetReportPanelToDefaultPosition(defaultSettings)
	if not isLoaded then
		return
	end

	AUI_Scrolling_Text_ReportPanel:ClearAnchors()	
	AUI_Scrolling_Text_ReportPanel:SetAnchor(defaultSettings.scrolling_text_report_position.point, GuiRoot, defaultSettings.scrolling_text_report_position.relativePoint, defaultSettings.scrolling_text_report_position.offsetX, defaultSettings.scrolling_text_report_position.offsetY)
	_, AUI.Settings.Combat.scrolling_text_report_position.point, _, AUI.Settings.Combat.scrolling_text_report_position.relativePoint, AUI.Settings.Combat.scrolling_text_report_position.offsetX, AUI.Settings.Combat.scrolling_text_report_position.offsetY = AUI_Scrolling_Text_ReportPanel:GetAnchor()
end

local function InsertPreviewMessages()
	if AUI.Settings.Combat.scrolling_text_show_damage_out then
		AUI.Combat.Text.InsertMessage(1600, AUI_SCROLLING_TEXT_DAMAGE_OUT, AUI_SCROLLING_TEXT_PANEL_OUT, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("damage"))
	end
	
	if AUI.Settings.Combat.scrolling_text_show_critical_damage_out then
		AUI.Combat.Text.InsertMessage(2500, AUI_SCROLLING_TEXT_CRIT_DAMAGE_OUT, AUI_SCROLLING_TEXT_PANEL_OUT, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("critical_damage"))
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_heal_out then
		AUI.Combat.Text.InsertMessage(400, AUI_SCROLLING_TEXT_HEAL_OUT, AUI_SCROLLING_TEXT_PANEL_OUT, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("healing"))	
	end
	
	if AUI.Settings.Combat.scrolling_text_show_critical_heal_out then
		AUI.Combat.Text.InsertMessage(750, AUI_SCROLLING_TEXT_CRIT_HEAL_OUT, AUI_SCROLLING_TEXT_PANEL_OUT, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("critical_healing"))		
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_damage_in then
		AUI.Combat.Text.InsertMessage(1600, AUI_SCROLLING_TEXT_DAMAGE_IN, AUI_SCROLLING_TEXT_PANEL_IN, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("damage"))	
	end
	
	if AUI.Settings.Combat.scrolling_text_show_critical_damage_in then
		AUI.Combat.Text.InsertMessage(2500, AUI_SCROLLING_TEXT_CRIT_DAMAGE_IN, AUI_SCROLLING_TEXT_PANEL_IN, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("critical_damage"))		
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_heal_in then
		AUI.Combat.Text.InsertMessage(400, AUI_SCROLLING_TEXT_HEAL_IN, AUI_SCROLLING_TEXT_PANEL_IN, "/esoui/art/icons/icon_missing.dds", AUI.L10n.GetString("healing"))
	end
	
	if AUI.Settings.Combat.scrolling_text_show_critical_heal_in then
		AUI.Combat.Text.InsertMessage(750, AUI_SCROLLING_TEXT_CRIT_HEAL_IN, AUI_SCROLLING_TEXT_PANEL_IN, "/esoui/art/icons/icon_missing.dds",  AUI.L10n.GetString("critical_healing"))	
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_exp then
		AUI.Combat.Text.InsertMessage(600, AUI_SCROLLING_TEXT_EXP, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end
	
	if AUI.Settings.Combat.scrolling_text_show_cxp then
		AUI.Combat.Text.InsertMessage(600, AUI_SCROLLING_TEXT_CXP, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_ap then
		AUI.Combat.Text.InsertMessage(150, AUI_SCROLLING_TEXT_AP, AUI_SCROLLING_TEXT_PANEL_REPORT)		
	end
	
	if AUI.Settings.Combat.scrolling_text_show_telvar then
		AUI.Combat.Text.InsertMessage(8, AUI_SCROLLING_TEXT_TELVAR, AUI_SCROLLING_TEXT_PANEL_REPORT)		
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_combat_start then
		AUI.Combat.Text.InsertMessage(AUI.L10n.GetString("combat_start"), AUI_SCROLLING_TEXT_COMBAT_START, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end
	
	if AUI.Settings.Combat.scrolling_text_show_combat_end then
		AUI.Combat.Text.InsertMessage(AUI.L10n.GetString("combat_end"), AUI_SCROLLING_TEXT_COMBAT_END, AUI_SCROLLING_TEXT_PANEL_REPORT)	
	end
	
	if AUI.Settings.Combat.scrolling_text_show_instant_casts then
		AUI.Combat.Text.InsertMessage(AUI.L10n.GetString("ability_proc_name"), AUI_SCROLLING_TEXT_PROC, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_ultimate_ready then
		AUI.Combat.Text.InsertMessage(AUI.L10n.GetString("ultimate_ready"), AUI_SCROLLING_TEXT_ULTI_READY, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end	
	
	if AUI.Settings.Combat.scrolling_text_show_potion_ready then
		AUI.Combat.Text.InsertMessage(AUI.L10n.GetString("potion_ready"), AUI_SCROLLING_TEXT_POTION_READY, AUI_SCROLLING_TEXT_PANEL_REPORT)
	end		
end

function AUI.Combat.Text.UpdatePreview(_panel)	
	if not isLoaded then
		return
	end

	if isPreviewShow and _panel then
		AUI.Animations.RemoveFrom(_panel)
			
		InsertPreviewMessages()	
	
		EVENT_MANAGER:UnregisterForUpdate("AUI_UPDATE_SCROLLING_TEXT_PREVIEW") 	
		EVENT_MANAGER:RegisterForUpdate("AUI_UPDATE_SCROLLING_TEXT_PREVIEW", 3000, InsertPreviewMessages)			
	end
end

function AUI.Combat.Text.ShowPreview()
	if not isLoaded then
		return
	end

	AUI_Scrolling_Text:SetHidden(false)
	
	AUI_Scrolling_Text_ReportPanel_BG:SetHidden(false)
	AUI_Scrolling_Text_ReportPanel:SetMouseEnabled(true)
	
	AUI_Scrolling_Text_OutgoingPanel_BG:SetHidden(false)
	AUI_Scrolling_Text_OutgoingPanel:SetMouseEnabled(true)
	
	AUI_Scrolling_Text_IncomingPanel_BG:SetHidden(false)
	AUI_Scrolling_Text_IncomingPanel:SetMouseEnabled(true)			
	
	SCROLLING_TEXT_SCENE_FRAGMENT.hiddenReasons:SetHiddenForReason("ShouldntShow", true)	
	
	isPreviewShow = true
	
	AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
	AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)	
	AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)	
end

function AUI.Combat.Text.HidePreview()
	if not isLoaded then
		return
	end

	AUI_Scrolling_Text:SetHidden(true)	
	
	AUI_Scrolling_Text_ReportPanel_BG:SetHidden(true)
	AUI_Scrolling_Text_ReportPanel:SetMouseEnabled(false)
	
	AUI_Scrolling_Text_OutgoingPanel_BG:SetHidden(true)
	AUI_Scrolling_Text_OutgoingPanel:SetMouseEnabled(false)
	
	AUI_Scrolling_Text_IncomingPanel_BG:SetHidden(true)
	AUI_Scrolling_Text_IncomingPanel:SetMouseEnabled(false)		
	
	SCROLLING_TEXT_SCENE_FRAGMENT.hiddenReasons:SetHiddenForReason("ShouldntShow", false)
	
	AUI.Animations.RemoveFrom(AUI_Scrolling_Text_ReportPanel)
	AUI.Animations.RemoveFrom(AUI_Scrolling_Text_OutgoingPanel)
	AUI.Animations.RemoveFrom(AUI_Scrolling_Text_IncomingPanel)
	
	EVENT_MANAGER:UnregisterForUpdate("AUI_UPDATE_SCROLLING_TEXT_PREVIEW") 	
		
	isPreviewShow = false
end

function AUI.Combat.Text.Load()
	if isLoaded then
		return
	end

	isLoaded = true	
	
	SCROLLING_TEXT_SCENE_FRAGMENT = ZO_SimpleSceneFragment:New(AUI_Scrolling_Text)	
	SCROLLING_TEXT_SCENE_FRAGMENT.hiddenReasons = ZO_HiddenReasons:New()		
    SCROLLING_TEXT_SCENE_FRAGMENT:SetConditional(function()
        return not SCROLLING_TEXT_SCENE_FRAGMENT.hiddenReasons:IsHidden()
    end)		
	
	HUD_SCENE:AddFragment(SCROLLING_TEXT_SCENE_FRAGMENT)
	HUD_UI_SCENE:AddFragment(SCROLLING_TEXT_SCENE_FRAGMENT)
	SIEGE_BAR_SCENE:AddFragment(SCROLLING_TEXT_SCENE_FRAGMENT)
	if SIEGE_BAR_UI_SCENE then
		SIEGE_BAR_UI_SCENE:AddFragment(SCROLLING_TEXT_SCENE_FRAGMENT)
	end	
	
	CreateUI()
	
	AUI.Combat.Text.UpdateUI()
	
	EVENT_MANAGER:RegisterForUpdate("AUI_UPDATE_SCROLLING_TEXT_INSERT_ASSEMBELD_DATA", 100, InsertAssembledData)
end